import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Spec, SpecParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商品规格组记录表
 */
export async function pageSpec(params: SpecParam) {
  const res = await request.get<ApiResult<PageResult<Spec>>>(
    MODULES_API_URL + '/shop/spec/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品规格组记录表列表
 */
export async function listSpec(params?: SpecParam) {
  const res = await request.get<ApiResult<Spec[]>>(
    MODULES_API_URL + '/shop/spec',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品规格组记录表
 */
export async function addSpec(data: Spec) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/spec',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品规格组记录表
 */
export async function updateSpec(data: Spec) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/spec',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品规格组记录表
 */
export async function removeSpec(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/spec/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品规格组记录表
 */
export async function removeBatchSpec(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/spec/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品规格组记录表
 */
export async function getSpec(id: number) {
  const res = await request.get<ApiResult<Spec>>(
    MODULES_API_URL + '/shop/spec/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
